﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     demo_FontProgram.h

  Copyright (C)2009-2013 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 50863 $
 *---------------------------------------------------------------------------*/

#ifndef DEMO_FONT_PROGRAM_OBJECT_H_
#define DEMO_FONT_PROGRAM_OBJECT_H_

#include "demo/ShaderProgram/demo_ProgramObject.h"

namespace demo
{ 
  
    /* Please see man pages for details 
        

        
    */

    class FontProgram : public ProgramObject
    {
    public:
        /* Please see man pages for details 
        

        
        */
        FontProgram(void);

        /* Please see man pages for details 
        

        
        */
        virtual ~FontProgram(void);

    public:
        /* Please see man pages for details 
        

        
        */
        virtual bool Initialize(const GLuint shaderId);

        /* Please see man pages for details 
        

        
        */
        virtual bool Finalize(void);

    public:
        /* Please see man pages for details 
        

        
        */
        virtual bool Begin(void);

        /* Please see man pages for details 
        

        
        */
        virtual bool Use(void);

        /* Please see man pages for details 
        

        
        */
        virtual bool End(void);
    
    protected:
        virtual void InitializeVertexAttributes(void);
        void InitializeFontTexture(void);

    protected:
        GLuint m_FontTextureId;
    };

}

#endif
